<template>
    <div class="card">
        <div class="card-body">
            <form>

                <div class=" form-group">
                    <label for="title">Title</label>
                    <input type="text" class="form-control" id="title" v-model="form.title"
                           :class="{'is-invalid' : $v.form.title.$error }"
                           @input="$v.form.title.$touch"
                           placeholder="Your story title">
                    <div v-if="$v.form.title.$error" class="invalid-feedback">
                        This field is required.
                    </div>
                </div>
                <div class="row">
                    <div class="col-6 form-group">
                        <label for="difficulty">Difficulty level</label>
                        <select class="form-control" id="difficulty" v-model="form.level"
                                :class="{'is-invalid' : $v.form.level.$error }"
                                @change="$v.form.level.$touch">
                            <option value="simple">Simple</option>
                            <option value="intermediate">Intermediate</option>
                            <option value="advance">Advance</option>
                        </select>
                        <div v-if="$v.form.level.$error" class="invalid-feedback">
                            This field is required.
                        </div>
                    </div>
                    <div class="col-6 form-group">
                        <label for="canRate" v-model="form.will_rate">Do you want to rate the answers</label>
                        <select class="form-control" v-model="form.will_rate"
                                :class="{'is-invalid' : $v.form.will_rate.$error }"
                                @change="$v.form.will_rate.$touch"
                                id="canRate">
                            <option value="true">Yes</option>
                            <option value="false">No</option>
                        </select>
                        <div v-if="$v.form.will_rate.$error" class="invalid-feedback">
                            This field is required.
                        </div>
                    </div>

                </div>
                <div class=" form-group">
                    <label for="ad">Inspire with your story</label>
                    <div>
                        <small>With one simple phrase get people's attention to your story</small>
                    </div>
                    <input v-model="form.ad" type="text" class="form-control" id="ad"
                           placeholder="The journey is beginning"
                           :class="{'is-invalid' : $v.form.ad.$error }"
                           @change="$v.form.ad.$touch"
                    >
                    <div v-if="$v.form.ad.$error" class="invalid-feedback">
                        This field is required.
                    </div>
                </div>
                <div class="form-group">
                    <vue-simplemde v-model="form.description" class="mb-4" ref="markdownEditor"
                                   :class="{'is-invalid' : $v.form.description.$error }"
                                   @input="$v.form.description.$touch"
                                   placeholder="Description"/>
                </div>

                <button type="button"  :disabled="$v.form.$invalid"
                        :class="{ disabled : $v.form.$invalid}" class="btn btn-primary" v-on:click="saveStory">Submit</button>
                <div>
                    <small v-if="$v.form.$error" class="text-danger">
                        Please check the form again.
                    </small>
                    <small v-if="showError" class="text-danger">
                        Something went wrong. Please try again
                    </small>
                </div>
            </form>
        </div>

    </div>

</template>

<script>
    import VueSimplemde from 'vue-simplemde'
    import {required} from 'vuelidate/lib/validators'

    export default {
        name: "StoryForm",
        components: {
            VueSimplemde
        },
        validations: {
            form: {
                title: {
                    required,
                },
                ad: {
                    required,
                },
                level: {
                    required,
                },
                will_rate: {
                    required,
                },
                description: {
                    required
                }
            }

        },
        props: {
            story: {type: Object,},
            showError: {type: Boolean, default: false}
        },
        data() {
            return {
                form: Object.assign({}, this.story)
            }

        },
        methods: {
            saveStory() {
                this.$emit('content-saved', this.form)
            }
        }
    }
</script>
